<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Test</title>
	<script src="/leaflet/leaflet-src.js"></script>
	<script src="/leaflet/leaflet.js"></script>
	<link rel="stylesheet" href="/leaflet/leaflet.css">
	<style>
		.leaflet-popup {
			bottom: 20px !important;
		}
		li {
			margin: 0 10px;
			cursor: pointer;
		}
		li:hover, li.selected {
			background-color: #AAA;
		}
	</style>
</head>
<body>
	<div>
		<div id="map" style="height: 600px"></div>
		<div id="POIs">

		</div>
	</div>
</body>
<script>

	function getDatas() {
		return fetch(`${process.env.VUE_APP_BACKEND_URL}/AtoB`, {
			method: "POST",
			headers: {
				"Content-Type": "application/json"
			},
			body: JSON.stringify({
				"from": "48.929710758740214, 2.0474655656313923",
				"to": "44.81720634646052, 6.482516339592868",
				"nbDays": 4,
				"nbStepsByDay": {
					"all": 4
				},
				"minimumDurationByStep": "00:30",
				"interests": [
					"museum",
					"tourguide",
					"attraction",
					"activities",
					"events",
					"garden",
					"regionalcuisine",
					"sights",
					"theater",
					"artgallerie",
					"musicvenue",
					"nightclub",
					"park",
					"hiking",
					"historicplace",
					"historic",
					"nature",
					"publicplace",
					"church",
					"temple",
					"gastropub"
				],
				"interestsRestaurant": [
					"pub",
					"bar",
					"food",
					"supermarket",
					"gastropub",
					"university",
					"schools",
					"liquor",
					"seafood",
					"library",
					"events",
					"club",
					"tapas",
					"regionalcuisine",
					"nightlife",
					"fastfood",
					"museum",
					"artgallerie",
				],
				"categoriesHostel": [7314008,7314005]
			})
		})
	}

	const map = L.map('map').setView([47.53092519322762, 2.3734923973713276], 6);

	L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
		attribution: '&copy; <a href="/copyright">OpenStreetMap</a> contributors'
	}).addTo(map);


	const Icon = L.Icon.extend({
		options: {}
	});

	const redIcon = new Icon({
		iconUrl: '/images/red-marker.ico',
		shadowUrl: '/leaflet/images/marker-shadow.png'
	});

	const greenIcon = new Icon({
		iconUrl: '/images/green-marker.ico',
		shadowUrl: '/leaflet/images/marker-shadow.png'
	});


	getDatas().then(res => res.json()).then(async ({road,restaurantPositions,hostelPositions}) => {
		/*const scale = 5;
		for (const road of roads) {
			for (let i=0;i<road.length-1;i+=scale) {
				const A = i;
				const B = Math.min(i+scale,road.length-1)
				const [lng1,lat1] = road[A];
				const [lng2,lat2] = road[B];
				L.polyline([
						L.latLng(lat1,lng1),
						L.latLng(lat2,lng2),
				], {
					color: 'blue'
				}).addTo(map)
			}
		}*/

		for (const {POIIndex,restaurants} of restaurantPositions) {
			for (const {name,lat,lng} of restaurants) {
				L.marker([lat, lng]).addTo(map)
						.bindPopup(name+" (restaurant after POI "+(parseInt(POIIndex)+1)+")")
						.openPopup();
			}
		}

		document.getElementById("POIs").innerHTML = "";
		const ul = document.createElement("ul");

		let i = 0;
		let sumR = 0;
		for (const {lat,lng,name,tags,category,rank} of road) {
			sumR += rank;
			const marker = L.marker([lat, lng]).addTo(map)
				.setIcon(redIcon)
				.bindPopup(name+" ("+(i+1)+") ["+category+"] ("+tags.join(",")+") rank: "+rank);

			const li = document.createElement("li");
			li.innerText = name+" ("+(i+1)+") ["+category+"] ("+tags.join(",")+") rank: "+rank;
			li.onclick = () => {
				marker.openPopup();
				for (const otherLi of document.querySelectorAll("li"))
					otherLi.classList.remove("selected");
				li.classList.add("selected");
			}
			ul.appendChild(li);

			i ++;
		}
		document.getElementById("POIs").appendChild(ul);
		console.log("Average rank => "+(sumR/road.length));

		for (const {POIIndex,hostels} of hostelPositions) {
			for (const hostel of hostels) {
				const {lat,lng,name} = hostel;
				L.marker([lat, lng]).addTo(map)
						.setIcon(greenIcon)
						.bindPopup(name+" (hostel before POI "+(parseInt(POIIndex)+1)+")")
						.openPopup()
			}
		}
	});
</script>
</html>
